# Python API


* [dataquality](api/dataquality.md)


    * [`login()`](api/dataquality.md#dataquality.login)


    * [`init()`](api/dataquality.md#dataquality.init)


    * [`log_model_outputs()`](api/dataquality.md#dataquality.log_model_outputs)


    * [`finish()`](api/dataquality.md#dataquality.finish)


    * [`set_labels_for_run()`](api/dataquality.md#dataquality.set_labels_for_run)


    * [`set_tasks_for_run()`](api/dataquality.md#dataquality.set_tasks_for_run)


    * [`set_epoch()`](api/dataquality.md#dataquality.set_epoch)


    * [`set_split()`](api/dataquality.md#dataquality.set_split)


    * [`log_data_sample()`](api/dataquality.md#dataquality.log_data_sample)


    * [`log_dataset()`](api/dataquality.md#dataquality.log_dataset)


    * [`auto()`](api/dataquality.md#dataquality.auto)


* [dataquality.integrations.torch](api/dataquality.md#dataquality-integrations-torch)


    * [`watch()`](api/dataquality.md#dataquality.integrations.torch.watch)


    * [`unwatch()`](api/dataquality.md#dataquality.integrations.torch.unwatch)


* [dataquality.integrations.transformers_trainer](api/dataquality.md#dataquality-integrations-transformers-trainer)


    * [`watch()`](api/dataquality.md#dataquality.integrations.transformers_trainer.watch)


    * [`unwatch()`](api/dataquality.md#dataquality.integrations.transformers_trainer.unwatch)


* [dataquality.integrations.keras](api/dataquality.md#dataquality-integrations-keras)


    * [`DataQualityCallback`](api/dataquality.md#dataquality.integrations.keras.DataQualityCallback)


    * [`DataQualityLoggingLayer`](api/dataquality.md#dataquality.integrations.keras.DataQualityLoggingLayer)


    * [`add_ids_to_numpy_arr()`](api/dataquality.md#dataquality.integrations.keras.add_ids_to_numpy_arr)


    * [`add_sample_ids()`](api/dataquality.md#dataquality.integrations.keras.add_sample_ids)


* [dataquality.integrations.experimental.keras](api/dataquality.md#dataquality-integrations-experimental-keras)


    * [`watch()`](api/dataquality.md#dataquality.integrations.experimental.keras.watch)


    * [`unwatch()`](api/dataquality.md#dataquality.integrations.experimental.keras.unwatch)


* [dataquality.integrations.spacy](api/dataquality.md#dataquality-integrations-spacy)


    * [`watch()`](api/dataquality.md#dataquality.integrations.spacy.watch)


    * [`unwatch()`](api/dataquality.md#dataquality.integrations.spacy.unwatch)


* [dataquality.integrations.hf](api/dataquality.md#dataquality-integrations-hf)


    * [`infer_schema()`](api/dataquality.md#dataquality.integrations.hf.infer_schema)


    * [`tokenize_and_log_dataset()`](api/dataquality.md#dataquality.integrations.hf.tokenize_and_log_dataset)


    * [`TextDataset`](api/dataquality.md#dataquality.integrations.hf.TextDataset)


    * [`get_dataloader()`](api/dataquality.md#dataquality.integrations.hf.get_dataloader)


* [dataquality](api/dataquality.md#id1)


    * [`AggregateFunction`](api/dataquality.md#dataquality.AggregateFunction)


    * [`Operator`](api/dataquality.md#dataquality.Operator)


    * [`Condition`](api/dataquality.md#dataquality.Condition)


    * [`ConditionFilter`](api/dataquality.md#dataquality.ConditionFilter)
